--- otherlibs/labltk/support/cltkFile.c.orig	2005-10-04 14:28:05.953125000 +0200
+++ otherlibs/labltk/support/cltkFile.c	2005-10-04 14:30:12.625000000 +0200
@@ -16,10 +16,6 @@
 
 /* $Id: cltkFile.c,v 1.12 2002/04/26 12:16:17 furuse Exp $ */
 
-#ifdef __CYGWIN__
-#define _WIN32
-#endif
-
 #ifdef _WIN32
 #include <wtypes.h>
 #include <winbase.h>
@@ -29,6 +25,7 @@
 #include <tk.h>
 #include <mlvalues.h>
 #include <callback.h>
+#include <fail.h>
 #include "camltk.h"
 
 /*
@@ -44,6 +41,33 @@
 
 #ifndef _WIN32
 
+#ifdef __CYGWIN__
+/* Cygwin: these functions are not supported. No way to
+ * create a Windows handle from a Cygwin descriptor.
+ */
+
+CAMLprim value camltk_add_file_input(value fd, value cbid)
+{
+	caml_failwith("cltkFile.c: not ported to Cygwin");
+}
+
+CAMLprim value camltk_rem_file_input(value fd, value cbid)
+{
+	caml_failwith("cltkFile.c: not ported to Cygwin");
+}
+
+CAMLprim value camltk_add_file_output(value fd, value cbid)
+{
+	caml_failwith("cltkFile.c: not ported to Cygwin");
+}
+
+CAMLprim value camltk_rem_file_output(value fd, value cbid)
+{
+	caml_failwith("cltkFile.c: not ported to Cygwin");
+}
+
+#else
+
 /* Under Unix, we use file handlers */
 
 /* Map Unix.file_descr values to Tcl file handles (for tcl 7)
@@ -102,6 +126,7 @@
   return Val_unit;
 }
 
+#endif
 #else
 
 /* Under Win32, we go through the generic channel abstraction */
